/*
 * ak4601.h  --  audio driver for ak4601
 *
 * Copyright (C) 2016 Asahi Kasei Microdevices Corporation
 *  Author                Date        Revision
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *   Tsuyoshi Mutsuro   16/03/18	    1.0
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 */

#define GPO_PDN_HIGH	1
#define GPO_PDN_LOW		0

#ifndef _AK4601_H
#define _AK4601_H
#define AK4601_I2C_IF

#define NUM_SYNCDOMAIN  2
#define NUM_SDIO		3 //AK4601 SDIN1~3 SDOUT1~3

/* User Setting */
#define AK4601_000_SYSTEM_CLOCK_SETTING_1			0x000
#define AK4601_001_SYSTEM_CLOCK_SETTING_2			0x001
#define AK4601_002_MIC_BIAS_POWER_MANAGEMENT		0x002
#define AK4601_003_SYNC_DOMAIN_1_SETTING_1			0x003
#define AK4601_004_SYNC_DOMAIN_1_SETTING_2			0x004
#define AK4601_005_SYNC_DOMAIN_2_SETTING_1			0x005
#define AK4601_006_SYNC_DOMAIN_2_SETTING_2			0x006
#define AK4601_007_RESERVED							0x007
#define AK4601_008_RESERVED							0x008
#define AK4601_009_RESERVED							0x009
#define AK4601_00A_RESERVED							0x00A
#define AK4601_00B_RESERVED							0x00B
#define AK4601_00C_RESERVED							0x00C
#define AK4601_00D_RESERVED							0x00D
#define AK4601_00E_RESERVED							0x00E
#define AK4601_00F_CLKO_OUTPUT_SETTING				0x00F
#define AK4601_010_PIN_SETTING						0x010
#define AK4601_011_SYNC_DOMAIN_SELECT_1				0x011
#define AK4601_012_RESERVED							0x012
#define AK4601_013_SYNC_DOMAIN_SELECT_3				0x013
#define AK4601_014_SYNC_DOMAIN_SELECT_4				0x014
#define AK4601_015_RESERVED							0x015
#define AK4601_016_SYNC_DOMAIN_SELECT_6				0x016
#define AK4601_017_SYNC_DOMAIN_SELECT_7				0x017
#define AK4601_018_SYNC_DOMAIN_SELECT_8				0x018
#define AK4601_019_SYNC_DOMAIN_SELECT_9				0x019
#define AK4601_01A_RESERVED							0x01A
#define AK4601_01B_RESERVED							0x01B
#define AK4601_01C_RESERVED							0x01C
#define AK4601_01D_RESERVED							0x01D
#define AK4601_01E_RESERVED							0x01E
#define AK4601_01F_SYNC_DOMAIN_SELECT_15			0x01F
#define AK4601_020_SYNC_DOMAIN_SELECT_16			0x020
#define AK4601_021_SDOUT1_TDM_SLOT1_2_DATA_SELECT	0x021
#define AK4601_022_SDOUT1_TDM_SLOT3_4_DATA_SELECT	0x022
#define AK4601_023_SDOUT1_TDM_SLOT5_6_DATA_SELECT	0x023
#define AK4601_024_SDOUT1_TDM_SLOT7_8_DATA_SELECT	0x024
#define AK4601_025_SDOUT1_TDM_SLOT9_10_DATA_SELECT	0x025
#define AK4601_026_SDOUT1_TDM_SLOT11_12_DATA_SELECT	0x026
#define AK4601_027_SDOUT1_TDM_SLOT13_14_DATA_SELECT	0x027
#define AK4601_028_SDOUT1_TDM_SLOT15_16_DATA_SELECT	0x028
#define AK4601_029_SDOUT2_OUTPUT_DATA_SELECT		0x029
#define AK4601_02A_SDOUT2_OUTPUT_DATA_SELECT		0x02A
#define AK4601_02B_RESERVED							0x02B
#define AK4601_02C_RESERVED							0x02C
#define AK4601_02D_RESERVED							0x02D
#define AK4601_02E_RESERVED							0x02E
#define AK4601_02F_RESERVED							0x02F
#define AK4601_030_RESERVED							0x030
#define AK4601_031_RESERVED							0x031
#define AK4601_032_RESERVED							0x032
#define AK4601_033_RESERVED							0x033
#define AK4601_034_RESERVED							0x034
#define AK4601_035_DAC1_INPUT_DATA_SELECT			0x035
#define AK4601_036_DAC2_INPUT_DATA_SELECT			0x036
#define AK4601_037_DAC3_INPUT_DATA_SELECT			0x037
#define AK4601_038_VOL1_INPUT_DATA_SELECT			0x038
#define AK4601_039_VOL2_INPUT_DATA_SELECT			0x039
#define AK4601_03A_VOL3_INPUT_DATA_SELECT			0x03A
#define AK4601_03B_RESERVED							0x03B
#define AK4601_03C_RESERVED							0x03C
#define AK4601_03D_RESERVED							0x03D
#define AK4601_03E_RESERVED							0x03E
#define AK4601_03F_RESERVED							0x03F
#define AK4601_040_RESERVED							0x040
#define AK4601_041_RESERVED							0x041
#define AK4601_042_RESERVED							0x042
#define AK4601_043_RESERVED							0x043
#define AK4601_044_RESERVED							0x044
#define AK4601_045_MIXER_A_CH1_INPUT_DATA_SELECT	0x045
#define AK4601_046_MIXER_A_CH2_INPUT_DATA_SELECT	0x046
#define AK4601_047_MIXER_B_CH1_INPUT_DATA_SELECT	0x047
#define AK4601_048_MIXER_B_CH2_INPUT_DATA_SELECT	0x048
#define AK4601_049_RESERVED							0x049
#define AK4601_04A_RESERVED							0x04A
#define AK4601_04B_RESERVED							0x04B
#define AK4601_04C_CLOCK_FORMAT_SETTING_1			0x04C
#define AK4601_04D_RESERVED							0x04D
#define AK4601_04E_RESERVED							0x04E
#define AK4601_04F_RESERVED							0x04F
#define AK4601_050_SDIN1_DIGITAL_INPUT_FORMAT		0x050
#define AK4601_051_SDIN2_DIGITAL_INPUT_FORMAT		0x051
#define AK4601_052_SDIN3_DIGITAL_INPUT_FORMAT		0x052
#define AK4601_053_RESERVED							0x053
#define AK4601_054_RESERVED							0x054
#define AK4601_055_SDOUT1_DIGITAL_OUTPUT_FORMAT		0x055
#define AK4601_056_SDOUT2_DIGITAL_OUTPUT_FORMAT		0x056
#define AK4601_057_SDOUT3_DIGITAL_OUTPUT_FORMAT		0x057
#define AK4601_058_RESERVED							0x058
#define AK4601_059_RESERVED							0x059
#define AK4601_05A_SDOUT_PHASE_SETTING				0x05A
#define AK4601_05B_RESERVED							0x05B
#define AK4601_05C_RESERVED							0x05C
#define AK4601_05D_RESERVED							0x05D
#define AK4601_05E_OUTPUT_PORT_ENABLE_SETTING		0x05E
#define AK4601_05F_RESERVED							0x05F
#define AK4601_060_MIXER_A_SETTING					0x060
#define AK4601_061_MIXER_B_SETTING					0x061
#define AK4601_062_MIC_AMP_GAIN						0x062
#define AK4601_063_ANALOG_INPUT_GAIN_CONTROL		0x063
#define AK4601_064_ADC1LCH_DIGITAL_VOLUME			0x064
#define AK4601_065_ADC1RCH_DIGITAL_VOLUME			0x065
#define AK4601_066_ADC2LCH_DIGITAL_VOLUME			0x066
#define AK4601_067_ADC2RCH_DIGITAL_VOLUME			0x067
#define AK4601_068_ADCM_DIGITAL_VOLUME				0x068
#define AK4601_069_RESERVED							0x069
#define AK4601_06A_RESERVED							0x06A
#define AK4601_06B_ANALOG_INPUT_SELECT_SETTING		0x06B
#define AK4601_06C_ADC_MUTE_AND_HPF_CONTROL			0x06C
#define AK4601_06D_DAC1LCH_DIGITAL_VOLUME			0x06D
#define AK4601_06E_DAC1RCH_DIGITAL_VOLUME			0x06E
#define AK4601_06F_DAC2LCH_DIGITAL_VOLUME			0x06F
#define AK4601_070_DAC2RCH_DIGITAL_VOLUME			0x070
#define AK4601_071_DAC3LCH_DIGITAL_VOLUME			0x071
#define AK4601_072_DAC3RCH_DIGITAL_VOLUME			0x072
#define AK4601_073_DAC_MUTE_AND_FILTER_SETTING		0x073
#define AK4601_074_DAC_DEM_SETTING					0x074
#define AK4601_075_VOL1LCH_DIGITAL_VOLUME			0x075
#define AK4601_076_VOL1RCH_DIGITAL_VOLUME			0x076
#define AK4601_077_VOL2LCH_DIGITAL_VOLUME			0x077
#define AK4601_078_VOL2RCH_DIGITAL_VOLUME			0x078
#define AK4601_079_VOL3LCH_DIGITAL_VOLUME			0x079
#define AK4601_07A_VOL3RCH_DIGITAL_VOLUME			0x07A
#define AK4601_07B_RESERVED							0x07B
#define AK4601_07C_RESERVED							0x07C
#define AK4601_07D_RESERVED							0x07D
#define AK4601_07E_RESERVED							0x07E
#define AK4601_07F_VOL_SETTING						0x07F
#define AK4601_080_RESERVED							0x080
#define AK4601_081_RESERVED							0x081
#define AK4601_082_RESERVED							0x082
#define AK4601_083_STO_FLAG_SETTING1				0x083
#define AK4601_084_RESERVED							0x084
#define AK4601_085_RESERVED							0x085
#define AK4601_086_RESERVED							0x086
#define AK4601_087_RESERVED							0x087
#define AK4601_088_RESERVED							0x088
#define AK4601_089_RESERVED							0x089
#define AK4601_08A_POWER_MANAGEMENT1				0x08A
#define AK4601_08B_RESERVED							0x08B
#define AK4601_08C_RESET_CONTROL					0x08C

#define AK4601_08D_RESERVED							0x08D
#define AK4601_08E_RESERVED							0x08E
#define AK4601_08F_RESERVED							0x08F
#define AK4601_090_RESERVED							0x090
#define AK4601_091_RESERVED							0x091
#define AK4601_092_RESERVED							0x092
#define AK4601_093_RESERVED							0x093
#define AK4601_094_RESERVED							0x094
#define AK4601_095_RESERVED							0x095
#define AK4601_096_RESERVED							0x096
#define AK4601_097_RESERVED							0x097
#define AK4601_098_RESERVED							0x098
#define AK4601_099_RESERVED							0x099
#define AK4601_09A_RESERVED							0x09A
#define AK4601_09B_RESERVED							0x09B
#define AK4601_09C_RESERVED							0x09C
#define AK4601_09D_RESERVED							0x09D
#define AK4601_09E_RESERVED							0x09E
#define AK4601_09F_RESERVED							0x09F
#define AK4601_0A0_RESERVED							0x0A0
#define AK4601_0A1_RESERVED							0x0A1
#define AK4601_0A2_RESERVED							0x0A2
#define AK4601_0A3_RESERVED							0x0A3
#define AK4601_0A4_RESERVED							0x0A4
#define AK4601_0A5_RESERVED							0x0A5
#define AK4601_0A6_RESERVED							0x0A6
#define AK4601_0A7_RESERVED							0x0A7
#define AK4601_0A8_RESERVED							0x0A8
#define AK4601_0A9_RESERVED							0x0A9
#define AK4601_0AA_RESERVED							0x0AA
#define AK4601_0AB_RESERVED							0x0AB
#define AK4601_0AC_RESERVED							0x0AC
#define AK4601_0AD_RESERVED							0x0AD
#define AK4601_0AE_RESERVED							0x0AE
#define AK4601_0AF_RESERVED							0x0AF
#define AK4601_0B0_RESERVED							0x0B0
#define AK4601_0B1_RESERVED							0x0B1
#define AK4601_0B2_RESERVED							0x0B2
#define AK4601_0B3_RESERVED							0x0B3
#define AK4601_0B4_RESERVED							0x0B4
#define AK4601_0B5_RESERVED							0x0B5
#define AK4601_0B6_RESERVED							0x0B6
#define AK4601_0B7_RESERVED							0x0B7
#define AK4601_0B8_RESERVED							0x0B8
#define AK4601_0B9_RESERVED							0x0B9
#define AK4601_0BA_RESERVED							0x0BA
#define AK4601_0BB_RESERVED							0x0BB
#define AK4601_0BC_RESERVED							0x0BC
#define AK4601_0BD_RESERVED							0x0BD
#define AK4601_0BE_RESERVED							0x0BE
#define AK4601_0BF_RESERVED							0x0BF
#define AK4601_0C0_RESERVED							0x0C0
#define AK4601_0C1_RESERVED							0x0C1
#define AK4601_0C2_RESERVED							0x0C2
#define AK4601_0C3_RESERVED							0x0C3
#define AK4601_0C4_RESERVED							0x0C4
#define AK4601_0C5_RESERVED							0x0C5
#define AK4601_0C6_RESERVED							0x0C6
#define AK4601_0C7_RESERVED							0x0C7
#define AK4601_0C8_RESERVED							0x0C8
#define AK4601_0C9_RESERVED							0x0C9
#define AK4601_0CA_RESERVED							0x0CA
#define AK4601_0CB_RESERVED							0x0CB
#define AK4601_0CC_RESERVED							0x0CC
#define AK4601_0CD_RESERVED							0x0CD
#define AK4601_0CE_RESERVED							0x0CE
#define AK4601_0CF_RESERVED							0x0CF
#define AK4601_0D0_RESERVED							0x0D0
#define AK4601_0D1_RESERVED							0x0D1
#define AK4601_0D2_RESERVED							0x0D2
#define AK4601_0D3_RESERVED							0x0D3
#define AK4601_0D4_RESERVED							0x0D4
#define AK4601_0D5_RESERVED							0x0D5
#define AK4601_0D6_RESERVED							0x0D6
#define AK4601_0D7_RESERVED							0x0D7
#define AK4601_0D8_RESERVED							0x0D8
#define AK4601_0D9_RESERVED							0x0D9
#define AK4601_0DA_RESERVED							0x0DA
#define AK4601_0DB_RESERVED							0x0DB
#define AK4601_0DC_RESERVED							0x0DC
#define AK4601_0DD_RESERVED							0x0DD
#define AK4601_0DE_RESERVED							0x0DE
#define AK4601_0DF_RESERVED							0x0DF
#define AK4601_0E0_RESERVED							0x0E0
#define AK4601_0E1_RESERVED							0x0E1
#define AK4601_0E2_RESERVED							0x0E2
#define AK4601_0E3_RESERVED							0x0E3
#define AK4601_0E4_RESERVED							0x0E4
#define AK4601_0E5_RESERVED							0x0E5
#define AK4601_0E6_RESERVED							0x0E6
#define AK4601_0E7_RESERVED							0x0E7
#define AK4601_0E8_RESERVED							0x0E8
#define AK4601_0E9_RESERVED							0x0E9
#define AK4601_0EA_RESERVED							0x0EA
#define AK4601_0EB_RESERVED							0x0EB
#define AK4601_0EC_RESERVED							0x0EC
#define AK4601_0ED_RESERVED							0x0ED
#define AK4601_0EE_RESERVED							0x0EE
#define AK4601_0EF_RESERVED							0x0EF
#define AK4601_0F0_RESERVED							0x0F0
#define AK4601_0F1_RESERVED							0x0F1
#define AK4601_0F2_RESERVED							0x0F2
#define AK4601_0F3_RESERVED							0x0F3
#define AK4601_0F4_RESERVED							0x0F4
#define AK4601_0F5_RESERVED							0x0F5
#define AK4601_0F6_RESERVED							0x0F6
#define AK4601_0F7_RESERVED							0x0F7
#define AK4601_0F8_RESERVED							0x0F8
#define AK4601_0F9_RESERVED							0x0F9
#define AK4601_0FA_RESERVED							0x0FA
#define AK4601_0FB_RESERVED							0x0FB
#define AK4601_0FC_RESERVED							0x0FC
#define AK4601_0FD_RESERVED							0x0FD
#define AK4601_0FE_RESERVED							0x0FE
#define AK4601_0FF_RESERVED							0x0FF
//Read Only
#define AK4601_100_RESERVED							0x100
#define AK4601_101_RESERVED							0x101
#define AK4601_102_STATUS_READ_OUT					0x102

#define AK4601_MAX_REGISTERS	(AK4601_102_STATUS_READ_OUT + 1)

/* Bitfield Definitions */
#define AK4601_LRIF_I2S_MODE		0
#define AK4601_LRIF_MSB_MODE		5
#define AK4601_LRIF_LSB_MODE		5

#define AK4601_PCM_BCKP

#ifndef AK4601_PCM_BCKP
#define AK4601_LRIF_PCM_SHORT_MODE	0xE
#define AK4601_LRIF_PCM_LONG_MODE	0xF
#else
#define AK4601_LRIF_PCM_SHORT_MODE	6
#define AK4601_LRIF_PCM_LONG_MODE	7
#endif

#define MAX_LOOP_TIMES		3

#define COMMAND_WRITE_REG			0xC0
#define COMMAND_READ_REG			0x40

enum {
	AIF_PORT1 = 0,
	AIF_PORT2,
	NUM_AIF_DAIS,
};

#endif

